/* ***** BEGIN LICENSE BLOCK *****
 * Licensed under Version: MPL 1.1/GPL 2.0/LGPL 2.1
 * Full Terms at http://mozile.mozdev.org/license.html
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is Playsophy code.
 *
 * The Initial Developer of the Original Code is Playsophy
 * Portions created by the Initial Developer are Copyright (C) 2002-2003
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *		James A. Overton <james@overton.ca>
 *      Andreas Schamberger <mozile@andreass.net>
 *		Paul Everitt
 *
 * ***** END LICENSE BLOCK ***** */

/*
	Shows RSD info.
	Current user/custom save info can be seen via the save dialog window but could be added here...

*/

function mozileInfoInit(event)
{
    if (event.target != document)
        return;
        
    mozileSetVersionById('version');
    
    mozileInfoRefresh (event);
        
/*
    var button = document.documentElement.getButton("extra2");
    button.setAttribute("label", document.documentElement.getAttribute("refreshlabel"));
    button.addEventListener("command", mozileInfoRefresh, true);
*/
}

function mozileInfoRefresh(event) 
{
	var f = ["info.js","mozileInfoRefresh"];

	var mozileTarget = opener.mozileGetCurrentTarget();

	//Clear all the values.
	try {
  	mozileInsertDescription( document.getElementById("mozileLocation"), "-" );
  	document.getElementById("mozileLocation").removeAttribute("class");
  	document.getElementById("mozileLocation").removeAttribute("onclick");
  	mozileInsertDescription( document.getElementById("mozileConfigurationFile"), "-" );
  	document.getElementById("mozileConfigurationFile").removeAttribute("class");
  	document.getElementById("mozileConfigurationFile").removeAttribute("onclick");
  	mozileInsertDescription( document.getElementById("mozilePresetDisallow"), "-" );
  	mozileInsertDescription( document.getElementById("mozileContent"), "-" );
  	mozileInsertDescription( document.getElementById("mozileContentDisallow"), "-" );
  	mozileInsertDescription( document.getElementById("mozileSaveMethod"), "-" );
  	mozileInsertDescription( document.getElementById("mozileSaveMethodDisallow"), "-" );
  	mozileInsertDescription( document.getElementById("mozileHttpSavePath"), "-" );
  	mozileInsertDescription( document.getElementById("mozileHttpSavePathModify"), "-" );
  	mozileInsertDescription( document.getElementById("mozileMES"), "-" );
  	document.getElementById("mozileMES").removeAttribute("class");
  	document.getElementById("mozileMES").removeAttribute("onclick");
  	mozileInsertDescription( document.getElementById("mozileTagView"), "-" );
  	document.getElementById("mozileTagView").removeAttribute("class");
  	document.getElementById("mozileTagView").removeAttribute("onclick");
  	mozileInsertDescription( document.getElementById("mozilePasteMode"), "-" );
	} catch (e) {
		opener.mozileDebug(f,1,"Exception: "+e );
	}
	
	if(mozileTarget != "") {
		try {
			mozileSetHyperlink( "mozileLocation", mozileTarget.document.location.href );

			if ( typeof(mozileTarget.document.MOZILE_RSD_CONFIG) != undefined ) {
				var rc = mozileTarget.document.MOZILE_RSD_CONFIG;
				if ( ("rsdhref" in rc) && (rc.rsdhref != "") ) {
					mozileSetHyperlink( "mozileConfigurationFile", rc.rsdhref );
					if (rc.savePresetDisallow)
						mozileInsertDescription( document.getElementById("mozilePresetDisallow"), rc.savePresetDisallow );
					if (rc.saveContent)
						mozileInsertDescription( document.getElementById("mozileContent"), rc.saveContent );
					if (rc.saveContentDisallow)
						mozileInsertDescription( document.getElementById("mozileContentDisallow"), rc.saveContentDisallow );
					if (rc.saveMethod)
						mozileInsertDescription( document.getElementById("mozileSaveMethod"), rc.saveMethod );
					if (rc.saveMethodDisallow) 
						mozileInsertDescription( document.getElementById("mozileSaveMethodDisallow"), rc.saveMethodDisallow );
					if (rc.httpSavePath)
						mozileInsertDescription( document.getElementById("mozileHttpSavePath"), rc.httpSavePath );
					if (rc.httpSavePathModify)
						mozileInsertDescription( document.getElementById("mozileHttpSavePathModify"), rc.httpSavePathModify );
					if (rc.mes)
						mozileSetHyperlink( "mozileMES", rc.mes );
					if (rc.tagCSS)
						mozileSetHyperlink( "mozileTagView", rc.tagCSS );
					if (rc.pasteMode)
						mozileInsertDescription( document.getElementById("mozilePasteMode"), rc.pasteMode );
				}
			}
		} catch(e) {
			opener.mozileDebug(f,1,"Exception: "+e );
		}
	}
	self.sizeToContent(); //Important to get display to update properly...
}

// Simulates a hyperlink
// I guess the proper thing to do is use a real hyperlink by inserting an html <a> tag???
//
function mozileSetHyperlink ( ElemID, url ) {
	var n = document.getElementById( ElemID );
	n.value =	url;
	if ( url ) {
		if ( url.substr(0,4) == "http" ) {
			n.setAttribute("class","link");
			n.setAttribute("onclick","mozileInfoOpen(this.value);");
		}
	}
}

// Could be improved...
// 
function mozileInfoOpen( location ) {
	if ( location ) {
		window.open( location );
	}
	return true;
}

// n = description node
// d = new text
//
function mozileInsertDescription( n, d ) {
	var f = ["info.js","mozileInsertDescription"];
	try {
		while( n.hasChildNodes() )
			n.removeChild( n.firstChild );
		n.appendChild( document.createTextNode(d) );
	} catch (e) {
		opener.mozileDebug(f,1,"Exception: "+e );
	}
}

